<?php

require_once('/usr/fallback/beroConf.php');
require_once('/usr/php/include/updateTool.php');

class apiCall {

	private $_name, $_get, $_post, $_files, $_execResult, $_execResultString;

	function __construct ($get = null, $post = null, $files = null) {
		$this->_name = 'FirmwareUpdate';
		$this->_get = $get;
		$this->_post = $post;
		$this->_files = $files;
		$this->_execResult = true;
		$this->_execResultString = 'success';
	}

	function execute () {

		$bc = new beroConf('root');
		if ($bc->get('root', 'boot_fwupdate') != 1) {
			$this->_execResultString = 'error:gateway_not_in_update_mode';
			$this->_execResult = false;
			return($this->_execResult);
		}

		$upd = new updateTool();

		# everything's alright, upload file
		$ret = $upd->upload($this->_files);
		if ($ret['message'] != false) {
			$this->_execResultString = (($ret['error'] == true) ? 'failed:' : 'warning:') . ' ' . $ret['message'];
			$this->_execResult = false;
			return($this->_execResult);
		}

		if (($ret['filename'] != false) && ($ret['error'] == false)) {
			if ($upd->install($ret['filename'], false) == false) {
				$this->_execResultString = 'error:install_failed';
				$this->_execResult = false;
				return($this->_execResult);
			}
		}

		return($this->_execResult);
	}

	function display () {
		return($this->_name . ':' . $this->_execResultString);
	}
}

?>
